function [R2Out, VOut] = BisectionGivenMultip(f, h, x, W, s, Gamma, VBasis, OptBis)


R2Low = OptBis.R2Low;
R2High = OptBis.R2High;
R2tol = OptBis.R2Tol;

VOut = polynomial(0);
R2Out = 0;

if R2Low>0
    R2 = R2Low;
    R2Low = 0;
else
    R2 = R2High/2;
end

while R2High - R2Low > R2tol    
    [isfeasp,V] = L2toL2sFixed(f, h, x, W, s, R2, Gamma, VBasis);
    if ~isfeasp
        R2High = R2;
    else
        R2Low = R2;
        R2Out = R2;
        VOut = V;
    end
    R2 = 0.5*(R2Low+R2High);
end