function [isfeasp,sOut] = L2toL2VFixed(f, h, x, W, V, R2, Gamma, sBasis)


if 1
    % PJS 6/4/2009 SOSOPT Code
    sOut = polynomial(0);
    s = polydecvar('c',sBasis,'mat');
    Vdot = jacobian(V,x)*f;
    sosineq{1} = -((R2-V)*s + Vdot - W'*W + h'*h/Gamma^2);
    sosineq{2} = s;
    [info,dopt] = sosopt(sosineq,[x;W]);
    isfeasp = info.feas;
    if isfeasp == 1
        sOut = subs(s,dopt);
    end     
else
    % Original SOSTOOLs Code
    sOut = polynomial(0);
    prog = sosprogram([x;W]);
    [prog,s] = sossosvar(prog,sBasis);

    Vdot = jacobian(V,x)*f;

    prog = sosineq(prog, -((R2-V)*s + Vdot - W'*W + h'*h/Gamma^2));

    [progSol,info] = sossolve(prog);

    isfeasp = check_feasp(info);
    if isfeasp == 1
        sOut = sosgetsol(progSol,s);
    end
end


