function [isfeasp,VOut] = L2toL2sFixed(f, h, x, W, s, R2, Gamma, VBasis)

if 1
    % PJS 6/4/2009 SOSOPT Code
    VOut = polynomial(0);
    V = polydecvar('c',VBasis,'vec');
    sosineq{1} = V;
    Vdot = jacobian(V,x)*f;
    sosineq{2} = -((R2-V)*s + Vdot - W'*W + h'*h/Gamma^2);
    [info,dopt] = sosopt(sosineq,[x;W]);
    isfeasp = info.feas;
    if isfeasp == 1
        VOut = subs(V,dopt);
    end
else
    % Original SOSTOOLs Code
    VOut = polynomial(0);
    prog = sosprogram([x;W]);

    [prog,V] = sospolyvar(prog,VBasis);
    prog = sosineq(prog,V);

    Vdot = jacobian(V,x)*f;
    prog = sosineq(prog, -((R2-V)*s + Vdot - W'*W + h'*h/Gamma^2));

    [progSol,info] = sossolve(prog);

    isfeasp = check_feasp(info);
    if isfeasp == 1
        VOut = sosgetsol(progSol,V);
    end
end