function [gL,Vout] = linearizedGain(f,h,x,w,l1)


gL = inf;
Vout = polynomial(0);


fLin = cleanpoly(f,[],1);
hLin = cleanpoly(h,[],1);
A = jacobian(fLin,x);
B = jacobian(fLin,w);
C = jacobian(hLin,x);


gsUp = 1e3;
gsLow = 0;
gs = gsUp;

if 1
    % PJS 6/4/2009 SOSOPT Code
    V = polydecvar('c',monomials(x,2),'vec');
    sosineq{1} = V-l1;
    sosineq{2} = gs*w'*w-x'*C'*C*x - jacobian(V,x)*(A*x+B*w);
    [info,dopt]=sosopt(sosineq,[x;w]);
    isfeasp = info.feas;
    if isfeasp
        gL = sqrt(gs);
        Vout = subs(V,dopt);
    end        
else
    % Original SOSTOOLs Code
    prog = sosprogram([x;w]);
    [prog,V] = sospolyvar(prog,monomials(x,2));
    prog = sosineq(prog, V-l1);
    ineq2 = gs*w'*w-x'*C'*C*x - jacobian(V,x)*(A*x+B*w);
    prog = sosineq(prog, ineq2);
    [prog, info] = sossolve(prog);
    isfeasp = check_feasp(info, 'sedumi');
    if isfeasp
        gL = sqrt(gs);
        Vout = sosgetsol(prog, V);
    end    
    clear prog V
end


while ~isfeasp
    gsLow = gsUp;
    gsUp = 2*gsUp;
    gs = gsUp;

    if 1
        % PJS 6/4/2009 SOSOPT Code
        V = polydecvar('c',monomials(x,2),'vec');
        sosineq{1} = V-l1;
        sosineq{2} = gs*w'*w-x'*C'*C*x - jacobian(V,x)*(A*x+B*w);
        [info,dopt] = sosopt(sosineq,[x;w]);
        isfeasp = info.feas;
        if isfeasp
            gL = sqrt(gs);
            Vout = subs(V,dopt);
        end
    else
        % Original SOSTOOLs Code
        prog = sosprogram([x;w]);
        [prog,V] = sospolyvar(prog,monomials(x,2));
        prog = sosineq(prog, V-l1);
        ineq2 = gs*w'*w-x'*C'*C*x - jacobian(V,x)*(A*x+B*w);
        prog = sosineq(prog, ineq2);
        [prog, info] = sossolve(prog);
        isfeasp = check_feasp(info, 'sedumi');
        if isfeasp
            gL = sqrt(gs);
            Vout = sosgetsol(prog, V);
        end
        clear prog V    
    end
end




while gsUp - gsLow > 1e-3
    gs = 0.5*(gsUp+gsLow);
    
    if 1
        % PJS 6/4/2009 SOSOPT Code
        V = polydecvar('c',monomials(x,2),'vec');
        sosineq{1} = V-l1;
        sosineq{2} = gs*w'*w-x'*C'*C*x - jacobian(V,x)*(A*x+B*w);
        [info,dopt] = sosopt(sosineq,[x;w]);
        isfeasp = info.feas;
        if isfeasp
            gsUp = gs;
            gL = sqrt(gs);
            Vout = subs(V,dopt);
        else
            gsLow = gs;
        end
    else
        % Original SOSTOOLs Code
        prog = sosprogram([x;w]);
        [prog,V] = sospolyvar(prog,monomials(x,2));
        prog = sosineq(prog, V-l1);
        ineq2 = gs*w'*w-x'*C'*C*x - jacobian(V,x)*(A*x+B*w);
        prog = sosineq(prog, ineq2);
        [prog, info] = sossolve(prog);
        isfeasp = check_feasp(info, 'sedumi');
        if isfeasp
            gsUp = gs;
            gL = sqrt(gs);
            Vout = sosgetsol(prog, V);
        else
            gsLow = gs;
        end
        clear prog V       
    end    
end

