function [isfeasp,Vout] = linearizedReach(f,x,w,l1)


Vout = polynomial(0);


fLin = cleanpoly(f,[],1);

A = jacobian(fLin,x);
B = jacobian(fLin,w);


if 1
    % PJS 6/4/2009 SOSOPT
    V = polydecvar('c',monomials(x,2),'vec');
    sosineq{1} = V-l1;
    sosineq{2} = w'*w - jacobian(V,x)*(A*x+B*w);
    [info,dopt]=sosopt(sosineq,[x;w]);
    isfeasp = info.feas;
    if isfeasp
        Vout = subs(V,dopt);
    end    
else
    % Original SOSTOOLs Code
    prog = sosprogram([x;w]);
    [prog,V] = sospolyvar(prog,monomials(x,2));
    prog = sosineq(prog, V-l1);
    ineq2 = w'*w - jacobian(V,x)*(A*x+B*w);
    prog = sosineq(prog, ineq2);
    [prog, info] = sossolve(prog);
    isfeasp = check_feasp(info, 'sedumi');
    if isfeasp
        Vout = sosgetsol(prog, V);
    end
end
