function [sys, x0,str,ts] = f18_sfcn(t, x ,u, flag, x_init)
%
% This is a S-function representation for the plant described in
% f18_plant.m .  
% This S-function is used for trimming and linearizing the aircraft.
% This S-function is being called in the f18_trim.mdl file. 

switch flag
    
    case 0 % initialize
        
    
        str =[];
        ts = [0 0];
      
        
        s = simsizes ;
        
        s.NumContStates = 6;
        s.NumDiscStates = 0;
        s.NumOutputs = 6;
        s.NumInputs = 3;
        s.DirFeedthrough = 0;
        s.NumSampleTimes = 1; 
        
        sys = simsizes(s);
        
        x0 = x_init;
        
    case 1  % derivative
  
        sys = f18_plant(t,x,u);
         
    case 3  % output
        
        sys = x ;
        
    case {2 4 9} 
        
        sys = [];
end