function isgloballystable = CheckGlobalStab(XList,fver,degV)

if 1
    % XXX PJS 5/21/2009 Updated to sosopt
    pvar epss
    V = polydecvar('V',monomials(XList,degV/2),'mat');
    Nf = size(fver,2);
    ineq = cell(Nf,1);
    ineq{1} = V;
    for i1 = 1:Nf
        ineq{i1+1} = -jacobian(V,XList)*fver(:,i1)-epss*XList'*XList;
    end

    obj = -epss; 
    opts = [];
    [info,dopt]=sosopt(ineq,XList,obj,[],opts);
    epss = double( subs(epss,dopt(:,1),dopt(:,2)) );

    isgloballystable = 0;
    if epss > 1e-6
        isgloballystable = 1;
    end
    
else
    % Original Code
    pvar epss
    prog = sosprogram(XList,epss);

    [prog,V] = sossosvar(prog,monomials(XList,degV/2));

    for i1 = 1:size(fver,2)
        prog = sosineq(prog, -jacobian(V,XList)*fver(:,i1)-epss*XList'*XList);
    end

    prog = sossetobj(prog,-epss);
    [prog,info] = sossolve(prog);

    epss = double(sosgetsol(prog,epss));

    isgloballystable = 0;
    if epss > 1e-6
        isgloballystable = 1;
    end
end
