%% Example (E4) from the paper (*)
% (*) Topcu, Packard, Seiler, "Local stability analysis using simulations
% and sum-of-squares programming," Automatica, 2008. 

%% 
% Form the vector field
pvar x1 x2 x3; 
x=[x1;x2;x3];
f = [-x(2);-x(3);-.915*x(1)+(1-0.915*x(1)^2)*x(2)-x(3)];



%%
% p, the basis vector for V and the iteration options (if not equal
% to the default values) need to be specified before generating the options
% structures
p = x'*[12.5000   -8.1000    3.0000
   -8.1000   20.8000   -8.5000
    3.0000    -8.5000   13.4000]*x;
zV = monomials(x,2:4);
Bis.flag = 0;
Bis.r1deg = 4;


%%
% Generate the options
[roaconstr,opt,sys] = GetRoaOpts(f, x, zV, p, Bis);
%%
% Modify the options 
opt.coordoptim.IterStopTol = 1e-4;
opt.display.roaest = 1;
%%
% Solve the problem
outputs = wrapper(sys,[],roaconstr,opt);
%%
% Extract the solution 
[V,beta,gamma,p,multip,betaUpper] = extractSol(outputs);
%%
beta
%%
betaUpper

[vol,volstd] = pvolume(V,gamma,[],10000);
%% 
% Volume of the ROA estimate
Volume = vol/(4*pi)*3

