%% Example (E6) from the paper (*)
% (*) Topcu, Packard, Seiler, "Local stability analysis using simulations
% and sum-of-squares programming," Automatica, 2008. 




%% 
% Form the vector field
pvar x1 x2 x3; 
x=[x1;x2;x3];
f = [-x(1)+x(2)*x(3)^2;-x(2)+x(1)*x(2);-x(3)];

%%
% p, the basis vector for V and the iteration options (if not equal
% to the default values) need to be specified before generating the options
% structures
p = x'*[0.2849    0.0356   -0.0008;
    0.0356    0.2888   -0.0014;
   -0.0008   -0.0014    0.2835]*x;
zV = monomials(x,2:4);
Bis.flag = 0;
Bis.r1deg = 4;

%%
% Generate the options
[roaconstr,opt,sys] = GetRoaOpts(f, x, zV, p, Bis);
opt.coordoptim.IterStopTol = 1e-4;
opt.display.roaest = 1;
opt.coordoptim.MaxIters = 30;
opt.sim.BetaInit = 2;
opt.sim.BetaMax = 2;
%%
% Solve the problem
outputs = wrapper(sys,[],roaconstr,opt);
%%
% Extract the solution 
[V,beta,gamma,p,multip,betaUpper] = extractSol(outputs);
%%
beta
%%
betaUpper

[vol,volstd] = pvolume(V,gamma,[],10000);
%% 
% Volume of the ROA estimate
Volume = vol/(4*pi)*3







