function  [L,U] = PolyCover(DelVert,d,g)

m = length(DelVert)/2;
DelVert = reshape(DelVert,2,m);
quadint = DelVert(2,:).^2 - DelVert(1,:).^2; quadint = .5*quadint';
linint = DelVert(2,:) - DelVert(1,:); linint = sum(linint);
for i1 = 1:m
    delDesc(i1) = (d(i1)-DelVert(1,i1))*(DelVert(2,i1)-d(i1));
end

for i1 = 1:length(g)
    maxdeg = full(max(max(g(i1).deg)));
    degs = maxdeg - 2;
    if ~even(degs) degs = degs + 1; end
    
    vec_ding = LOCALWhichOfd(g(i1),d);
    vec1Len = length(find(vec_ding==1));

    %% upper bound computation
    for i2 = 1:m
        if vec_ding(i2) == 1
            varname = {['a' int2str(i2)]};
            coef = 1;
            matdim = [ 1 1];
            deg = 1;
            a(i2,1) = polynomial(coef,deg,varname,matdim);
        else
            a(i2,1) = polynomial(0);
        end
    end
    pvar b 
    aaux = a(find(a ~= 0));
    prog = sosprogram(d(find(vec_ding==1)), [aaux;b]);
    expr = -g(i1) + a'*d + b;
    for i2 = 1:m
        [prog,s(i1)] = sossosvar(prog, monomials(d(find(vec_ding==1)), 0:degs));
        expr = expr - s(i1)*delDesc(i2);
    end
    prog = sosineq(prog,expr);
    prog = sossetobj(prog, a'*quadint + b*linint);
    [prog,info] = sossolve(prog);
    for i2 = 1:m
        if vec_ding(i2) == 1
            U(i2,i1) = double(sosgetsol(prog,polynomial(1,1,{['a' int2str(i2)]},[1 1])));
        else
            U(i2,i1) = 0;
        end
    end
    U(m+1,i1) = double(sosgetsol(prog,b));

    clear prog a b s expr
    %% lower bound computation
    for i2 = 1:m
        if vec_ding(i2) == 1
            varname = {['a' int2str(i2)]};
            coef = 1;
            matdim = [ 1 1];
            deg = 1;
            a(i2,1) = polynomial(coef,deg,varname,matdim);
        else
            a(i2,1) = polynomial(0);
        end
    end
    pvar b 
    aaux = a(find(a ~= 0));
    prog = sosprogram(d(find(vec_ding==1)), [aaux;b]);
    expr = g(i1) - a'*d - b;
    for i2 = 1:m
        [prog,s(i1)] = sossosvar(prog, monomials(d(find(vec_ding==1)), 0:degs));
        expr = expr - s(i1)*delDesc(i2);
    end
    prog = sosineq(prog,expr);
    prog = sossetobj(prog, -(a'*quadint + b*linint));
    [prog,info] = sossolve(prog);
    for i2 = 1:m
        if vec_ding(i2) == 1
            L(i2,i1) = double(sosgetsol(prog,polynomial(1,1,{['a' int2str(i2)]},[1 1])));
        else
            L(i2,i1) = 0;
        end
    end
    L(m+1,i1) = double(sosgetsol(prog,b));

    clear prog a b s expr
end



%%%%%%%%%%%%%%%%%%%%%%%%
function vec = LOCALWhichOfd(g,d)

vec = zeros(length(d),1);
for i1 = 1:length(d)
    if ismember(d(i1).varname,g.varname)
        vec(i1) = 1;
    end
end





