function sys = fUnc2fAff( f, x)

dvecaux = [];
for i1 = 1:f.nvars
    % XXX PJS 5/20/2009 Updated polynomial to allow cell string inputs
    %if ~ismember(polynomial(1, 1, f.varname(i1),[1 1]),x);
    %    dvecaux = [dvecaux; polynomial(1, 1, f.varname(i1),[1 1])];
    %end
    if ~ismember(polynomial(f.varname(i1)),x);
        dvecaux = [dvecaux; polynomial(f.varname(i1))];
    end
end
sys.delvector = dvecaux;
d = dvecaux;

sys.fWithDel = f;
sys.x = x;

if isempty(d)
    sys.f = f;
    sys.delvector = [];
    sys.nonaffine = [];
    return
end
    

maxdeg = 0;
for i1 = 1:length(f)
    [aux, xaux, daux] = collect(f(i1),x);
    if xaux == 0
        xfv{i1} = [aux];
        dfv{i1} = [polynomial(1)];
    else
        xfv{i1} = [aux;xaux'];
        dfv{i1} = [polynomial(1);daux'];
    end
    
    maxdeg = max([maxdeg, dfv{i1}.maxdeg]);
end

dbasis = monomials(d,0:maxdeg);


dfV = [];
for i1 = 1:length(f)
    dfV = [dfV poly2basis(dfv{i1}',dbasis)];
end
dfV = unique(dfV','rows')';

ind = zeros(size(dfV,2),1);
for i1 = 1:size(dfV,2)
    if sum(abs(dfV(:,i1))) ~= 0
        ind(i1) = 1;
    end
end

dfV = dfV(:,find(ind==1));



sys.nonaffine = [];
sys.f = polynomial(zeros(length(f),size(dfV,2)));

daux = polynomial(zeros(size(dfV,2),1));

for i1 = 1:size(dfV,2)
    aux = dbasis'*dfV(:,i1);
    daux(i1) = aux; 
    if aux ~= polynomial(1) & ~any(ismember(aux,d))
        sys.nonaffine = [sys.nonaffine; aux];
    end
    tmpf = polynomial(zeros(size(f)));
    for i2 = 1:length(f)
        
        [ism,loc] = ismember(aux,dfv{i2}) ;
        if any(ism)
            tmpf(i2) = xfv{i2}(find(loc==1));
        end
    end
    sys.f(:,i1) = tmpf;
end

faux = polynomial(zeros(size(sys.f)));
[ism,loc0] = ismember(polynomial(1),daux);
ind0 = find(loc0==1);
faux(:,1) = sys.f(:,ind0);

for i1 = 1:length(d);
    [ism,loc1] = ismember(d(i1),daux);
    ind1(i1) = find(loc1==1);
    faux(:,i1+1) = sys.f(:,ind1(i1));
end

ind = setdiff(1:length(daux),[ind0 ind1]);
faux(:,end-length(ind)+1:end) = sys.f(:,ind);

sys.f = faux;











    