function [Anom,Aver,stabnom,stabver,iscellstab] = getLinearization(fnom,fver,x,xeq)


% display('In getLinearization');
% size(fnom)
% size(fver)

Anom = []; Aver = [];
iscellstab = 0;
stabnom = zeros(size(fnom,2),1);
stabver = zeros(size(fver,2),1);

% display('form Anom');

if ~isempty(stabnom)
    Anom = jacobian(fnom,x);
    Anom = double(subs(Anom,x,xeq));
    if max(real(eig(Anom))) < 0 stabnom = 1; end
end

% display('form Aver');

for i1 = 1:size(fver,2)
%     i1
%     display('line 1');
    aux = jacobian(fver(:,i1),x);
%     display('line 2');
    Aver(:,:,i1) = double(subs(aux,x,xeq));
%     display('line 3');
    if max(real(eig(Aver(:,:,i1)))) < 0 stabver(i1) = 1; end
%     display('last line');
end
% display('Form the optimization problem in getLinearization');

if 1
    
    % XXX UT 5/24/2009 Updated to sosopt
    m = length(x);
    pvar stabfactor
    ineq{1} = 1000-stabfactor;
    ineq{2} = stabfactor+1000;
    Vv = polydecvar('Vv',monomials(x,2:2),'vec');
    ineq{length(ineq)+1} = Vv - 1e-6*x'*x;
    ineq{length(ineq)+1} = 1e3*x'*x - Vv;
    indaux = length(ineq);
    for i1 = 1:size(fver,2);
        faux = Aver(:,:,i1)*x;
        ineq{i1+indaux} = -jacobian(Vv,x)*faux-x'*stabfactor*eye(m)*x;
    end

    if size(fver,2) == 0
        faux = Anom*x;
        ineq{length(ineq)+1} = -jacobian(Vv,x)*faux-x'*stabfactor*eye(m)*x; ;
    end

    [info,dopt]=sosopt(ineq,x, -stabfactor);
    isfeasp = info.feas;
    stabfactor = subs(stabfactor,dopt(:,1),dopt(:,2));
    if isfeasp == 1 & double(stabfactor) > 1e-8
        iscellstab = 1;
    end
    
    
    
%     % XXX PJS 5/21/2009 Updated to LMILab
%     setlmis([])
%     m = length(x);
%     P = lmivar(1,[m,1]);
%     [stabfactor,ndec] = lmivar(1,[1,1]);
%     
%     % c1*I < P < c2*I
%     lmiterm([-1 1 1 P],1,1);
%     lmiterm([1 1 1 0],1e-6*eye(m));
%     
%     lmiterm([2 1 1 P],1,1);
%     lmiterm([-2 1 1 0],1e6*eye(m));
%     
%     % c1*I < stabfactor < c2*I
%     lmiterm([-1 1 1 stabfactor],1,1);
%     lmiterm([1 1 1 0],-1000);
%     
%     lmiterm([2 1 1 stabfactor],1,1);
%     lmiterm([-2 1 1 0],1000);
%     
%     % A'*P + P*A < -stabfactor*I
%     for i1 = 1:size(fver,2);
%         lmiterm([(i1+2) 1 1 P],Aver(:,:,i1)',1,'s');
%         lmiterm([(i1+2) 1 1 stabfactor],eye(m),eye(m));
%     end
%     if size(fver,2) == 0
%         lmiterm([3 1 1 P],Anom',1,'s');
%         lmiterm([3 1 1 stabfactor],eye(m),eye(m));
%     end
%     
%     lmisys = getlmis;
%     c = zeros(ndec,1);
%     c(end) = -1;
%     opts = [0 0 0 0 1];
%     [copt,xopt] = mincx(lmisys,c,opts);
%     stabfactor = xopt(end);
%     if stabfactor > 1e-8
%         iscellstab = 1;
%     end
    
else
    % Original Code
    sdpvar stabfactor
    m = length(x);
    P = sdpvar(m);
    F = set(-1e6<P(:)<1e6) + set(P>1e-6*eye(m));
    F = F + set(-1000<stabfactor<1000);
    F = F + set(trace(P)<1);
    for i1 = 1:size(fver,2);
    % 	F = F + set(Aver(:,:,i1)'*P+P*Aver(:,:,i1) < -LinearStabFactor*eye(m));
            F = F + set(Aver(:,:,i1)'*P+P*Aver(:,:,i1) < -stabfactor*eye(m));
    end

    if size(fver,2) == 0
        F = F + set(Anom'*P+P*Anom < -stabfactor*eye(m));
    end

    yalmipOpt = sdpsettings;
    yalmipOpt.verbose = 0;
    diagnostics = solvesdp(F,-stabfactor,yalmipOpt);
    if diagnostics.problem == 0 & double(stabfactor) > 1e-8
        iscellstab = 1;
    end

end