function info = getNewV(fList, XList,s1, s2, s3, copt, Gamma, Beta)

% max beta subject (6),(7), (8) with fixed multipliers (mu stuff included)

szF = size(fList);
Nsys = szF(2);

zV = copt.zV;
p = copt.p;
L1 = copt.L1;
L2 = copt.L2;
mu = copt.mu;

x = XList;

% pvar Bet Gam
Bet = Beta;
Gam = Gamma;

if 1 
    % XXX PJS 5/21/2009 Updated to sosopt
    V = polydecvar('V',zV,'vec');
    gradV = jacobian(V,x);
    ineq = cell(Nsys+2,1);
    for i1 = 1:Nsys
        Vd = gradV*fList(:,i1);
        ineq{i1} = -((Gam-V)*s2(i1) + (Vd+mu*V)*s3(i1) + L2);
    end
    ineq{Nsys+1} = -((Bet-p)*s1+(V-Gam));
    ineq{Nsys+2} = V - L1;
    opts = [];
    [info,dopt]=sosopt(ineq,x,[],[],opts);
    isfeasp = info.feas;
    if isfeasp
        info.V = subs( V, dopt(:,1), dopt(:,2) );    
        info.Beta = Beta;
        info.Gamma = Gamma;
    else
        info.V = [];
        info.Beta = Beta;
        info.Gamma = Gamma;
    end
    
else
    % Original Code
    
    % prog = sosprogram(x,[Gam;Bet]);
    % prog = sosprogram(x,[Bet]);
    prog = sosprogram(x);


    % this will create V as V = zV'*alpha (as opposed to zV'*M*zV with some Gram matrix M)!!! 
    [prog, V] = sospolyvar(prog, zV);



    for i1 = 1:Nsys
        Vd = jacobian(V,x)*fList(:,i1);
        ineq1 = -((Gam-V)*s2(i1) + (Vd+mu*V)*s3(i1) + L2);
        prog = sosineq(prog,[ineq1]);
    end

    ineq2 = -((Bet-p)*s1+(V-Gam));
    ineq3 = V - L1;

    prog = sosineq(prog,[ineq2;ineq3;Bet;Gam]);

    % prog = sossetobj(prog, -Bet);

    [prog,info] = sossolve(prog,[],[],'sedumi');


    isfeasp = double(check_feasp(info,'sedumi')==1);
    if isfeasp
        info.V = sosgetsol(prog, V);
    %     info.Beta = double(sosgetsol(prog, Bet));
            info.Beta = Beta;
    %     info.Gamma = double(sosgetsol(prog, Gam));
        info.Gamma = Gamma;
    else
        info.V = [];
    %     info.Beta = 0;
            info.Beta = Beta;
    %     info.Gamma = 0;
        info.Gamma = Gamma;
    end

end