function [Vnew, PhiVecNew] = sampleForV( XList, fList, A, b, phivec, opt, roaconstr, nofVs)

% [Vnew, PhiVecNew] = sampleForV( XList, fList, info.SimLFG.LP.A,info.SimLFG.LP.b, info.SimLFG.Vfeas.c, opt, roaconstr)


nofpts = opt.sampleV.nofptsEachTime;
useLin = opt.sampleV.useLin;
useVsos = opt.sampleV.useVsos;
mu = roaconstr.mu;
L1 = roaconstr.L1;
L2 = roaconstr.L2;
zV = roaconstr.zV;

N = length(zV);

phivec = double(phivec);


i1 = 1;


if 1
    % XXX PJS 5/21/2009 Updated to sossopt
    while i1 <= nofpts
        y = rand(N,1) - 0.5; 
        pertb = y / norm(y,2);
        t=(b-A*phivec)./(A*pertb);
        iPos=find(t >0);
        iNeg=find(t<0);
        tPos=min(t(iPos));  
        tNeg=max(t(iNeg));
        if useVsos
            pvar tp tn
            Vp = (phivec+tp*pertb)'*zV;
            Vn = (phivec+tn*pertb)'*zV;

            ineq = [];
            ineq{1} = Vp-L1;
            ineq{2} = Vn-L1;
            ineq{3} = tp;
            ineq{4} = -tn;
            obj = tn-tp;
            opts = [];
            [info,dopt]=sosopt(ineq,XList,obj,[],opts);
            isfeasp = info.feas;
            
            tpa = 0; tna = 0; 
            if isfeasp         
                tpa = double(subs(tp,dopt(:,1),dopt(:,2)));
                tna = double(subs(tn,dopt(:,1),dopt(:,2)));
            end
            tPos = min([tPos,tpa]);
            tNeg = max([tNeg,tna]);
        end

        if useLin
            pvar tp tn
            zV1 = cleanpoly(zV,[],2);
            Vp = (phivec+tp*pertb)'*zV1;
            Vn = (phivec+tn*pertb)'*zV1;
            
            Nf = size(fList,2);
            ineq = cell(2*Nf+2,1);
            for i2 = 1:Nf
                Vdot = jacobian(Vp,XList)*cleanpoly(fList(:,i2),[],1);
                ineq{i2} = -Vdot-L2;
                Vdot = jacobian(Vn,XList)*cleanpoly(fList(:,i2),[],1);
                ineq{Nf+i2} = -Vdot-L2;
            end
            ineq{2*Nf+1} = tp;
            ineq{2*Nf+2} = tn;
            obj = tn-tp;
            opts = [];
            [info,dopt]=sosopt(ineq,XList,obj,[],opts);
            isfeasp = info.feas;

            tpa = 0; tna = 0; 
            if isfeasp         
                tpa = double(subs(tp,dopt(:,1),dopt(:,2)));
                tna = double(subs(tn,dopt(:,1),dopt(:,2)));
            end
            tPos = min([tPos,tpa]);
            tNeg = max([tNeg,tna]);
        end

        tend = tNeg + rand*(tPos - tNeg);

        phivec = phivec + tend*pertb;
        PhiVecNew(:,i1) = phivec;
        Vnew(i1) = zV'*phivec;
        i1 = i1 + 1;
    end
    
else
    % Original Code    
    while i1 <= nofpts
        y = rand(N,1) - 0.5; 
        pertb = y / norm(y,2);
        t=(b-A*phivec)./(A*pertb);
        iPos=find(t >0);
        iNeg=find(t<0);
        tPos=min(t(iPos));  
        tNeg=max(t(iNeg));
        if useVsos
            pvar tp tn
            prog = sosprogram(XList,[tp;tn]);
            Vp = (phivec+tp*pertb)'*zV;
            Vn = (phivec+tn*pertb)'*zV;

            prog = sosineq(prog, Vp-L1);
            prog = sosineq(prog, Vn-L1);
            prog = sosineq(prog, tp);
            prog = sosineq(prog, -tn);

            prog = sossetobj(prog,tn-tp);

            [prog,info] = sossolve(prog);
            isfeasp = double(check_feasp(info,'sedumi')==1);
            tpa = 0; tna = 0; 
            if isfeasp         
                tpa = double(sosgetsol(prog,tp));
                tna = double(sosgetsol(prog,tn));
            end
            tPos = min([tPos,tpa]);
            tNeg = max([tNeg,tna]);
            clear tp tn prog
        end

        if useLin
            pvar tp tn
            prog = sosprogram(XList,[tp;tn]);
            zV1 = cleanpoly(zV,[],2);
            Vp = (phivec+tp*pertb)'*zV1;
            Vn = (phivec+tn*pertb)'*zV1;
            for i2 = 1:size(fList,2)
                Vdot = jacobian(Vp,XList)*cleanpoly(fList(:,i2),[],1);
                prog = sosineq(prog, -Vdot-L2);
                Vdot = jacobian(Vn,XList)*cleanpoly(fList(:,i2),[],1);
                prog = sosineq(prog, -Vdot-L2);

            end
            prog = sosineq(prog, tp);
            prog = sosineq(prog, -tn);

            prog = sossetobj(prog,tn - tp);
            [prog,info] = sossolve(prog);
            isfeasp = double(check_feasp(info,'sedumi')==1);

            tpa = 0; tna = 0; 
            if isfeasp         
                tpa = double(sosgetsol(prog,tp));
                tna = double(sosgetsol(prog,tn));
            end
            tPos = min([tPos,tpa]);
            tNeg = max([tNeg,tna]);
            clear tp tn prog
        end

            tend = tNeg + rand*(tPos - tNeg);

            phivec = phivec + tend*pertb;
            PhiVecNew(:,i1) = phivec;
            Vnew(i1) = zV'*phivec;
            i1 = i1 + 1;
    end
    
end

m = floor(nofpts/nofVs);
Vnew = Vnew(m:m:nofpts);
PhiVecNew = PhiVecNew(:,m:m:nofpts);
        
 