function [isfeasp, gamma, rout] = vdotcontain_Affine(V , x, f, zr, mu, opt, GammaCurrent)

try
    solver = opt.coordoptim.solver;
catch
    keyboard
end
% backOffFactor = opt.getgamma.backOffFactor;
GammaUpper = opt.getgamma.maxgamma;

if 1
    % XXX PJS 5/20/2009 Updated to sossopt
    opts.solver = solver;
    pvar g    
    obj = -g;
    
    Vd = jacobian(V,x)*f;
    r = polydecvar('r',zr,'vec');

    degzr = max(max(zr.degmat));
    degf = max(max(f.degmat));    
    d = ceil((-1+degf+degzr)/2);
    ineq{1} = (V-g)*sum(x.^(2*d))-(Vd+mu*V)*r;
    ineq{2} = GammaUpper - g;
    ineq{3} = g - GammaCurrent;
    [info,dopt]=sosopt(ineq,x,obj,[],opts);
    isfeasp = info.feas;
    
    rout = polynomial(0);
    gamma = GammaCurrent;
    if isfeasp 
        gamma = max([0; double(subs(g,dopt(:,1),dopt(:,2)))]);
        rout = subs(r,dopt(:,1),dopt(:,2));
    elseif GammaCurrent > 0
        gamma = GammaCurrent;
        obj = [];
        [info,dopt]=sosopt(ineq(1),x,obj,[],opts);
        rout = subs(r,dopt(:,1),dopt(:,2)); 
        isfeasp = info.feas;
    end
    
else

    % Original Code
    pvar g
    prog = sosprogram(x,g);
    Vd = jacobian(V,x)*f;
    [prog,r] = sospolyvar(prog,zr);

    degzr = max(max(zr.degmat));
    degf = max(max(f.degmat));
    degV = max(V.degmat);
    d = ceil((-1+degf+degzr)/2);

    prog = sossetobj(prog, -g);

    ineq = (V-g)*sum(x.^(2*d))-(Vd+mu*V)*r;
    prog = sosineq(prog,[ineq]);
    prog = sosineq(prog, GammaUpper - g);
    prog = sosineq(prog, g - GammaCurrent);
    [prog,info] = sossolve(prog,[],[],solver);
    isfeasp = double(check_feasp(info,solver)==1);

    rout = polynomial(0);
    gamma = GammaCurrent;


    if isfeasp 
        gamma = max([0;double(sosgetsol(prog, g))]);
        rout = sosgetsol(prog, r);
    elseif GammaCurrent > 0
        gamma = GammaCurrent;
        clear prog 
        prog = sosprogram(x);
        Vd = jacobian(V,x)*f;
        [prog,r] = sospolyvar(prog,zr);
        ineq = (V-gamma)*sum(x.^(2*d))-(Vd+mu*V)*r;
        prog = sosineq(prog,[ineq]);
        [prog,info] = sossolve(prog,[],[],solver);
        rout = sosgetsol(prog, r);
    end
end

