function [BetaOut, VOut] =...
    NewVForGainBasedROA(f, h, x, W, p, sB, sV, VBasis, R2, Gamma, mu, L1, BetaCurrent)



if 1
    % XXX PJS 6/8/2009 New code with SOSOPT
    BetaOut = BetaCurrent;

    VOut = polynomial(0);
    V = polydecvar('c',VBasis,'vec');
    ineq = cell(size(f,2)+2,1);
    ineq{1} = V - L1;

    for i1 = 1:size(f,2)
        Vdot = jacobian(V,x)*f(:,i1);
        ineq{i1+1}=-((R2-V)*sV(i1) + Vdot + mu*V - W'*W + h'*h/Gamma^2);
    end
    ineq{end} =  -((BetaCurrent-p)*sB - (R2-V));
    [info,dopt] = sosopt(ineq,[x;W]);
    isfeasp = info.feas;
    if isfeasp ==1
        VOut = subs(V,dopt);
    end
else
    % Original SOSTOOLS code
    BetaOut = BetaCurrent;

    VOut = polynomial(0);
    prog = sosprogram([x;W]);
    [prog, V] = sospolyvar(prog,VBasis);
    prog = sosineq(prog, V - L1);

    for i1 = 1:size(f,2)
        Vdot = jacobian(V,x)*f(:,i1);
        prog = sosineq(prog, -((R2-V)*sV(i1) + Vdot + mu*V - W'*W + h'*h/Gamma^2));
    end
    prog = sosineq(prog, -((BetaCurrent-p)*sB - (R2-V)));

    [progSol,info] = sossolve(prog);
    isfeasp = check_feasp(info);

    VOut = sosgetsol(progSol,V);
end

