function [isfeasp,sOut] = checkR2GivenV(f, h, x, W, V, R2, Gamma, sBasis, mu)


if 1
    % XXX PJS 6/8/2009 New code with SOSOPT    
    ineq1 = cell(size(f,2),1);
    ineq2 = cell(size(f,2),1);
    s = polynomial(zeros(size(f,2),1));
    for i1 = 1:size(f,2)
        sOut(i1) = polynomial(0);
        s(i1) = polydecvar(['cs' int2str(i1)],sBasis,'mat');
        ineq1{i1} = s(i1);

        Vdot = jacobian(V,x)*f(:,i1);
        ineq2{i1} = -((R2-V)*s(i1) + Vdot + mu*V - W'*W + h'*h/Gamma^2);
    end
    ineq = [ineq1;ineq2];
    [info,dopt] = sosopt(ineq,[x;W]);
    isfeasp = info.feas;
    if isfeasp == 1
        for i1 = 1:size(f,2)
            sOut(i1) = subs(s(i1),dopt);
        end
    end

else
    % Original SOSTOOLS code
    prog = sosprogram([x;W]);
    for i1 = 1:size(f,2)


        sOut(i1) = polynomial(0);

        [prog,s(i1)] = sossosvar(prog,sBasis);

        Vdot = jacobian(V,x)*f(:,i1);

        prog = sosineq(prog, -((R2-V)*s(i1) + Vdot + mu*V - W'*W + h'*h/Gamma^2));
    end

    [progSol,info] = sossolve(prog);

    isfeasp = check_feasp(info);
    if isfeasp == 1
        for i1 = 1:size(f,2)
            sOut(i1) = sosgetsol(progSol,s(i1));
        end
    end

end

