



function [bOut,ROut,VOut,sVOut,sBOut] =...
              roaViaGain(f,h,x,w,gainUnmodeled, rVgCons, opts)

          
          
%%%%%%%%%%%%%%%%%%%%%%%%%%%          
p = rVgCons.p ;%= x'*x;
l1 = rVgCons.l1 ;%= 1e-6*x'*x;
sVBasis = rVgCons.sVBasis ;%= monomials([x(1:4);w],1:1);
sBBasis = rVgCons.sBBasis ;%= monomials([x(1:4)],0:0);
VBasis = rVgCons.VBasis ;%= monomials(x,2:2);


OptBis = opts.OptBis;
MaxIter = opts.MaxIter ;%= 40;
StopTol = opts.StopTol ;%= 1e-6;
          
          
          
          
          
          
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%          

mu = 0;
bOut = 0;
ROut = 0;
VOut = polynomial(0);
sVOut = polynomial(0);
sBOut = polynomial(0);


[gL,VL] = linearizedGain(f,h,x,w,l1);

if gL*gainUnmodeled*1.01 < 1
    gamma = gainUnmodeled/1.01;
    V = linearizedGivenGain(f,h,x,w,l1,1.01*gL);
    k = 1;
    [R2, sV] = BisectionR2GivenV(f, h, x, w, V, gamma, sVBasis, OptBis, mu);
    [Beta, sB] = BisectionBetaGivenVR2(x, V, p, R2, sBBasis, OptBis);
    BetaInc = 100;
    BetaCurrent = 0;
    k = 1;
    while (BetaInc > StopTol) & (k <= MaxIter)
        [Beta,V] = NewVForGainBasedROA(f, h, x, w, p, sB, sV, VBasis, R2, gamma, mu, l1, BetaCurrent);
        [R2, sV] = BisectionR2GivenV(f, h, x, w, V, gamma, sVBasis, OptBis, mu);
        [Beta, sB] = BisectionBetaGivenVR2(x, V, p, R2, sBBasis, OptBis);
        fprintf('--Iteration = %d; Beta = %d \n', k,Beta);
        BetaInc = Beta - BetaCurrent;
        BetaCurrent = Beta;
        k = k + 1;
    end
end
    
bOut = double(BetaCurrent);
ROut = sqrt(double(R2));
VOut = V;
sVOut = sV;
sBOut = sB;




    





