function out  = PVget(a,property)
% function Out = PVget(A,Property)
%
% DESCRIPTION
%   (INTERNAL FUNCTION)
%   Private get for polydecvar objects.
%
% INPUTS
%   A: a polydecvar
%   Property: polydecvar property
%
% OUTPUTS
%   Out: Value of the property
%
% SYNTAX
%   Out = PVget(A,Property);

% 5/29/2009: PJS  Initial coding for polydecvar objects (based on
%                      polynomial/PVget)

switch property

    case 'PropNames'
        % These are getable and setable PUBLIC properties  
        % for the polydecar ( there are also derived properties
        % from the polynomial object )
        out.GPropNames = {'decvars'; 'monomials'; 'type'};

        out.SPropNames = {};
    case 'decvars'
        out = a.decvars;
        
    case 'monomials'
        out = a.monomials;
        
    case 'type'
        out = a.type;
        
    otherwise
        error(['Property ' property ' is Invalid']);
        
end



