% SOSOPTDEMO1 --- Sum of Squares Test
% Section 3.1 of SOSTOOLS User's Manual
% 

% =============================================
% Define polynomial variables
pvar x1 x2;          
                     
% =============================================
% Define polynomial
p = 2*x1^4 + 2*x1^3*x2 - x1^2*x2^2 + 5*x2^4;

% =============================================
% Call sosopt to see if p is an SOS
% Either kernel or image form can be used.
opts = [];
opts.form = 'image';
%opts.form = 'kernel';

[info,dopt,sossol] = sosopt(p,opts);

% =============================================
% Check for feasibility of solution
% If p(x1,x2) is SOS then the optimization will 
% return a Gram Matrix decomposition in sossol
fprintf('\n----------------Results');
if info.feas
    fprintf('\nSOS Optimization is feasible: p is a sum of squares\n');
    w = sossol{2};
    Q = sossol{3};
else
    fprintf('\nSOS Optimization is not feasible: p is NOT a sum of squares\n');    
    return
end

% =============================================
% Verify the Gram Marix Decomposition in sossol
e = p - w'*Q*w;
fprintf('\nMax magnitude coefficient of p-w''*Q*w is:')
disp(full(max(abs(e.coefficient))))
fprintf('Minimum eigenvalue of Q is:')
disp(min(eig(Q)));

